'''
   MAC0122 Princípios de Desenvolvimento de Algoritmos
 
   NÃO MODIFIQUE ESTE ARQUIVO

   Este arquivo contem o programa principal do projeto.
'''

#------------------------------------------------------------
# Calculadora.eval(), Calculadora.troca_modo_verboso() e
# Calculadora.motre_variaveis()
from calculadora import Calculadora

#------------------------------------------------------------
# CONSTANTES
PROMPT           = 'calc >>> '
QUIT             = 'fim'
VERBOSO          = 'ver'
EXIBA_DICIONARIO = 'dic'

#------------------------------------------------------------
def main():
    '''None -> None

    Programa que lê do teclado  expressões aritméticas 
    em notação infixa e calcula e imprime seus valores.
    '''
    
    print()
    print("==================================================")
    print("     C A L C U L A D O R A    P O L O N E S A     ")
    print("==================================================")
    print()    

    mostre_uso()
    
    # crie calculadora para expressões polonesa
    hp = Calculadora()

    # interprete cada expressão ou comando
    expressao = input(PROMPT)
    while expressao != QUIT:
        # trocar o modo verboso?
        if expressao == VERBOSO:
            hp.troca_modo_verboso()

        # exibir variáveis da calculadora?
        elif expressao == EXIBA_DICIONARIO:
            hp.mostre_variaveis()

        # temos uma expressão para ser avaliada    
        else:
            resultado = hp.eval(expressao)
            if resultado != None:
                print("%g" %resultado)

        # leia próxima expressão    
        expressao = input(PROMPT)        

    print("Curta a nossa página no feiçebuqui.\n")
    
#-------------------------------------------------------------
def mostre_uso():
    """(None) -> None

    Mostra como a calculadora deve ser usada.
    """
    print('Digite: ')
    print('  - uma expressão em notação infixa como "soma = 2 + 3"; ou')
    print('  - "ver" para ligar/desligar o modo verboso; ou')
    print('  - "dic" para exibir o dicionário de variáveis; ou')
    print('  - "fim" para terminar.')
    print()
    print('Operadores possíveis:')
    print('   + - * / % :cinco operações aritméticas básicas')
    print('   ^ : exponeciação')
    print('   ! : menos unário')
    print('   = : atribuição')
    print()

    
#-------------------------------------------
# início da execução do programa
main()
        
